<?php

use EventPortal\Domain\Comment\Models\Comment;
use EventPortal\Domain\Approval\Models\Approval;
use Faker\Generator;

/** @var \Illuminate\Database\Eloquent\Factory $factory */

$factory->define(Comment::class, static function (Generator $faker) {
    return [
        'comment' => $faker->words(20, true),
        'reason' => $faker->randomElement([
            'Overall Meeting Title',
            'Agenda Title',
            'Service Time',
            'Cost Per Head for subsistence',
            'PI',
            'Wrong Form Used',
            'Incorrect Document Uploaded',
            'Preparation Time',
            'Further Information Required',
            'Missing Info on MIF',
            'Spelling & Grammar',
            'Further Justification Needed',
            'Accommodation Details',
            'Conflicting Info on Agenda',
            'Slides',
            'Cost Centre/Internal Order number',
            'Missing Info on MIF',
            'Missing Info on MIF',
        ])
    ];
});

$factory->state(Comment::class, 'event_approval', static function (Generator $faker) {
    $approval = factory(Approval::class)->create();

    return [
        'comment' => $faker->words(20, true),
        'commentable_type' => Approval::class,
        'commentable_id' => $approval->id,
    ];
});

$factory->state(Comment::class, 'snapshot', static function () {
    return [
        'comment' => 'here is a comment',
    ];
});

$factory->state(Comment::class, 'event_approval_snapshot', static function () {

    $approval = factory(Approval::class)->create();

    return [
        'comment' => 'here is a comment',
        'commentable_type' => Approval::class,
        'commentable_id' => $approval->id,
    ];
});
