<?php

namespace EventPortal\Domain\Event\Form\ValueObjects;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Support\Arr;

class StepData implements Arrayable
{
    /** @var int */
    public $id;

    /** @var string */
    public $name;

    /** @var int */
    public $order;

    /** @var string */
    public $uuid;

    /** @var \Illuminate\Support\Collection */
    public $sections;

    public function __construct(array $step)
    {
        $this->id = Arr::get($step, 'id');
        $this->name = Arr::get($step, 'name');
        $this->order = (int) Arr::get($step, 'order');
        $this->uuid = Arr::get($step, 'uuid');
        $this->sections = collect(Arr::get($step, 'sections'))
            ->mapInto(SectionData::class)
            ->filter();
    }

    public function toArray(): array
    {
        return [
            'id' => $this->id,
            'name' => $this->name,
            'order' => $this->order,
            'uuid' => $this->uuid,
        ];
    }
}
